#Расскомментируйте этот код,
#и внесите необходимые правки в версию и путь,
#чтобы работать с установленным вручную (не через hashicorp provider registry) провайдером
/*
terraform {
  required_providers {
    decort = {
      source = "basis/decort/decort"
      version = "<VERSION>"
    }
  }
}
*/

provider "decort" {
  authenticator  = "oauth2"
  oauth2_url     = "https://sso.digitalenergy.online"
  controller_url = "https://mr4.digitalenergy.online"
  app_id         = ""
  app_secret     = ""
}

resource "decort_k8s_cp" "cp" {
  # Название кластера
  # Обязательный параметр
  # string
  name = "k8s-cp"

  # K8sCI ID
  # Обязательный параметр
  # int
  k8sci_id = 55

  # Плагин сети (flannel, weavenet или calico)
  # Обязательный параметр
  # string
  network_plugin = "flannel"

  # ID ресурсной группы
  # Обязательный параметр
  # int
  rg_id = 1387

  # Кол-во ядер мастер-узла
  # Опциональный параметр
  # int
  cpu = 2

  # Объем RAM мастер-узла
  # Опциональный параметр
  # int
  ram = 2048

  # Кол-во ВМ мастер-узла (1 или 3)
  # Опциональный параметр
  # int
  num = 1

  # Размер диска мастер-узла
  # Опциональный параметр
  # int
  disk = 10

  # Описание кластера
  # Опциональный параметр
  # string
  desc = "<DESCRIPTION>"

  # ID внешней сети
  # Опциональный параметр
  # id
  extnet_id = 13

  # Storage Endpoint ID
  # Опциональный параметр
  # id
  sep_id = 0

  # SEP Pool
  # Опциональный параметр
  # string
  sep_pool = "pool"

  # Старт/Стоп кластера
  # Опциональный параметр
  # bool
  start = true

  # Создать кластер с/без балансировщика нагрузки
  # Опциональный параметр
  # bool
  with_lb = true
}

output "cp_out" {
  value = decort_k8s_cp.cp
}
